/*
 * Copyright 2010-2013 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: Vector of Reaction Pairs
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <vector>

//#include <hw/component.hpp>
//#include <hw/message.hpp>
#include <hw/diagnostics/reaction_pair.hpp>

namespace cpptesk {
namespace hw {
namespace diagnostics {

class ReactionPairVector
{
public:
    ReactionPairVector();
    ~ReactionPairVector();

//    inline void clear() { _reaction_group.clear(); }

    int size();
    bool is_empty();
    void add_reaction_pair(ReactionPair reaction_pair);
    ReactionPair& operator[] (int index);

protected:
    std::vector<ReactionPair> _reaction_pairs;
};

}}}
