/*
 * Copyright 2010-2013 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: Remove NORMAL reaction pair
//           Rule #1: {[a,a] -> [x,x]}
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <hw/diagnostics/rules/rule.hpp>

namespace cpptesk {
namespace hw {
namespace diagnostics {

class Rule1: public Rule
{
public:
    Rule1() {}
 
    virtual ~Rule1() {}

    void assign_rule_number(ReactionUnit &ru1, ReactionUnit &ru2,
                            int rule, CollapseType type);

    virtual int check(cpptesk::hw::Reaction &r1, cpptesk::hw::Reaction &r2);
    virtual ReactionUnitVector apply(ReactionUnit &ru1, ReactionUnit &ru2);
    virtual std::string toString();
};

}}}
